package com.fp.persistence.pgeneral.gene;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENELABEL*/
@Embeddable
public class TgeneLabelKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="LABEL", nullable=false,updatable=false)

/**
* Codigo de etiqueta 
*/
private String label;

@Column(name="LANGUAGECODE", nullable=false,updatable=false)

/**
* Codigo de idioma
*/
private String languagecode;

@Column(name="CHANNELCODE", nullable=false,updatable=false)

/**
* Codigo de canal.
*/
private String channelcode;

/**Contructor por defecto*/
public TgeneLabelKey(){}
/**Contructor de TgeneLabelKey
@param pLabel Codigo de etiqueta 
@param pLanguagecode Codigo de idioma
@param pChannelcode Codigo de canal.
*/
public TgeneLabelKey(String pLabel,String pLanguagecode,String pChannelcode){
 label=pLabel;
 languagecode=pLanguagecode;
 channelcode=pChannelcode;
}
/**Obtiene el valor de label
@return valor de label*/
public String getLabel(){
  return label;
}
/**Fija el valor de label
@param pLabel nuevo Valor de label*/
public void setLabel(String pLabel){
  label=pLabel;
}

/**Obtiene el valor de languagecode
@return valor de languagecode*/
public String getLanguagecode(){
  return languagecode;
}
/**Fija el valor de languagecode
@param pLanguagecode nuevo Valor de languagecode*/
public void setLanguagecode(String pLanguagecode){
  languagecode=pLanguagecode;
}

/**Obtiene el valor de channelcode
@return valor de channelcode*/
public String getChannelcode(){
  return channelcode;
}
/**Fija el valor de channelcode
@param pChannelcode nuevo Valor de channelcode*/
public void setChannelcode(String pChannelcode){
  channelcode=pChannelcode;
}

/**Implementación de la comparación de TgeneLabelKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneLabelKey))return false;
  TgeneLabelKey that = (TgeneLabelKey) o;
  if (this.getLabel() == null || that.getLabel() == null){
      return false;
  }
  if (! this.getLabel().equals(that.getLabel())){
    return false;
  }
  if (this.getLanguagecode() == null || that.getLanguagecode() == null){
      return false;
  }
  if (! this.getLanguagecode().equals(that.getLanguagecode())){
    return false;
  }
  if (this.getChannelcode() == null || that.getChannelcode() == null){
      return false;
  }
  if (! this.getChannelcode().equals(that.getChannelcode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneLabelKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getLabel() == null ? 0 : this.getLabel().hashCode());
    result = result * 37 + (this.getLanguagecode() == null ? 0 : this.getLanguagecode().hashCode());
    result = result * 37 + (this.getChannelcode() == null ? 0 : this.getChannelcode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
